package com.weChatmarket.controller;

import java.io.PrintWriter;
import java.security.MessageDigest;
import java.util.Arrays;
import java.util.HashMap;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.weChatmarket.contens.BaseResult;
import com.weChatmarket.contens.ResultCodeEnum;
import com.wordnik.swagger.annotations.Api;
import com.wordnik.swagger.annotations.ApiOperation;
import com.wordnik.swagger.annotations.ApiParam;

@RestController
@Api(value = "用户登入")
@RequestMapping(value = "/user")
public class UserController {

	@Value("${userLogin}")
	private String userLogin; // 用户名

	@Value("${passWord}")
	private String passWord; // 密码

	@RequestMapping(value = "/logIn", method = { RequestMethod.POST })
	@ApiOperation(value = "用户登入", notes = "用户登入", response = String.class)
	public BaseResult<Object> logIn(HttpServletRequest request,
			HttpServletResponse response,
			@ApiParam(value = "用户名") @RequestParam String user,
			@ApiParam(value = "密码") @RequestParam String pass) {
		BaseResult<Object> result = new BaseResult<>();
		if (user.equals(userLogin) && pass.equals(passWord)) {
			HttpSession session =request.getSession(true);
			session.setAttribute("user", userLogin);
			String sessionId = session.getId();
			Cookie  ckSessionId = new Cookie("weChat-market",sessionId);
            ckSessionId.setMaxAge(1*1*24*60*60); 
            response.addCookie(ckSessionId);  //保存登录sessionId到COOKIE
			HashMap<String, Object> data = new HashMap<>();
			data.put("user", userLogin);
			result.setData(data);
		} else {
			result.setCode(ResultCodeEnum.HTTP_PARAMS_ERROR.getCode());
			result.setMsg("用户名或密码有误");
		}
		return result;
	}
	@RequestMapping(value = "/logOut", method = { RequestMethod.POST })
	@ApiOperation(value = "用户退出", notes = "用户退出", response = String.class)
	public BaseResult<Object> logIn(HttpServletRequest request) {
		BaseResult<Object> result = new BaseResult<>();
		request.getSession().removeAttribute("user");
		return result;
	}
	// 
	@RequestMapping(value = "/wx", method = { RequestMethod.GET })
	@ApiOperation(value = "根据id查找", notes = "根据id查找", response = String.class)
	public void test(HttpServletRequest request, HttpServletResponse response) {
		// 获取参数配置
		String signature = request.getParameter("signature");
		// 获取时间托
		String timestamp = request.getParameter("timestamp");
		String nonce = request.getParameter("nonce");
		// 获取echostr 字符
		String echostr = request.getParameter("echostr");
		// 获取token 此token跟需跟微信公众号的token一致；
		String token = "zmkmdsz";
		String str = "";
		try {
			// 判断是否为空
			if (null != signature) {
				// 声明一个存储数据字符数组
				String[] ArrTmp = { token, timestamp, nonce };
				Arrays.sort(ArrTmp);
				StringBuffer sb = new StringBuffer();
				for (int i = 0; i < ArrTmp.length; i++) {
					sb.append(ArrTmp[i]);
				}
				// 获取消息对象
				MessageDigest md = MessageDigest.getInstance("SHA-1");
				// 声明一个字节流数组；
				byte[] bytes = md.digest(new String(sb).getBytes());
				// 声明一个字符流
				StringBuffer buf = new StringBuffer();
				for (int i = 0; i < bytes.length; i++) {
					if (((int) bytes[i] & 0xff) < 0x10) {
						buf.append("0");
					}
					buf.append(Long.toString((int) bytes[i] & 0xff, 16));
				}
				if (signature.equals(buf.toString())) {
					str = echostr;
				}
			}
			PrintWriter out = response.getWriter();
			// 输出
			out.print(str);
			// 刷新
			out.flush();
			// 关闭流
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
